// Generated by CoffeeScript 1.12.6
var Semaphore, exports;

Semaphore = (function() {
  function Semaphore(max) {
    this.available = max;
    this.queue = [];
  }

  Semaphore.prototype.enter = function(fn) {
    this.queue.push(fn);
    return this.runAvailable();
  };

  Semaphore.prototype.leave = function() {
    this.available++;
    return this.runAvailable();
  };

  Semaphore.prototype.runAvailable = function() {
    var fn;
    if (this.queue.length === 0) {
      return;
    }
    if (this.available === 0) {
      return;
    }
    this.available--;
    fn = this.queue.shift();
    return fn();
  };

  Semaphore.prototype.destroy = function() {
    this.available = 0;
    return this.queue = [];
  };

  return Semaphore;

})();

module.exports = exports = Semaphore;
